<?php

namespace Wincher\Controller;

class AuthController extends RestController
{
    public function signup(\WP_REST_Request $request)
    {
        $host = preg_replace('/^www./i', '', trim($_SERVER['HTTP_HOST']));

        $resp = $this->wincherClient->signup(
            $request->get_param('email'),
            $request->get_param('first_name'),
            $request->get_param('last_name'),
            $request->get_param('password'),
            $request->get_param('search_engine'),
            $host
        );

        if ($resp['status'] === 201) {
            return $this->install($resp);
        }

        return new \WP_REST_Response($resp['data'], $resp['status']);
    }

    public function token(\WP_REST_Request $request)
    {
        $resp = $this->wincherClient->token(
            $request->get_param('email'),
            $request->get_param('password')
        );

        if ($resp['status'] === 200) {
            return $this->install($resp);
        }

        return new \WP_REST_Response($resp['data'], $resp['status']);
    }

    private function install($resp) {
        update_option('wincher_api_key', $resp['data']['access_token']);
        return new \WP_REST_Response([], 204);
    }
}
