<?php

namespace Wincher\Controller;

use Wincher\WincherClient;

abstract class RestController
{
    /**
     * @var WincherClient
     */
    protected $wincherClient;

    /**
     * RestController constructor.
     *
     * @param WincherClient $wincherClient
     */
    public function __construct($wincherClient)
    {
        $this->wincherClient = $wincherClient;
    }

    /**
     * Returns whether or not the user has permission.
     *
     * @return bool
     */
    public function hasPermission() {
        return current_user_can($this->getPermission());
    }

    /**
     * Returns the required permission to access this controller.
     *
     * @return string
     */
    protected function getPermission()
    {
        return 'manage_options';
    }
}
