<?php

namespace Wincher\Controller;

class StatusController extends RestController
{
    public function get(\WP_REST_Request $request)
    {
        $state = get_option('wincher_api_key', '') ? 'installed' : 'new';
        $currentUser = wp_get_current_user();
        $account = null;
        $domains = [];

        if ($state === 'installed') {
            $account = $this->wincherClient->getAccount()['data'];
            $domains = $this->wincherClient->getDomains()['data']['results'];
        }

        return new \WP_REST_Response([
            'state' => $state,
            'wp_user' => [
                'email' => $currentUser->user_email,
                'first_name' => $currentUser->first_name,
                'last_name' => $currentUser->last_name
            ],
            'account' => $account,
            'domains' => $domains
        ], 200);
    }
}
